Whamcloud - gitweb
LU-11518 ldlm: control lru_size for extent lock
[fs/lustre-release.git] / lustre / tests / sanity.sh
index 513ecae..b6363ae 100755 (executable)
@@ -41,8 +41,8 @@ init_logging
 ALWAYS_EXCEPT="$SANITY_EXCEPT "
 # bug number for skipped test: LU-9693 LU-6493 LU-9693
 ALWAYS_EXCEPT+="               42a     42b     42c "
-# bug number:    LU-8411 LU-9054 LU-13314
-ALWAYS_EXCEPT+=" 407     312   56ob"
+# bug number:    LU-8411 LU-9054
+ALWAYS_EXCEPT+=" 407     312"
 
 if $SHARED_KEY; then
        # bug number:    LU-9795 LU-9795 LU-9795 LU-9795
@@ -63,8 +63,8 @@ if [[ $(uname -m) = aarch64 ]]; then
        ALWAYS_EXCEPT+=" 45       317"
 fi
 
-# skip nfs tests on kernels >= 4.14.0 until they are fixed
-if [ $LINUX_VERSION_CODE -ge $(version_code 4.14.0) ]; then
+# skip nfs tests on kernels >= 4.12.0 until they are fixed
+if [ $LINUX_VERSION_CODE -ge $(version_code 4.12.0) ]; then
        # bug number:   LU-12661
        ALWAYS_EXCEPT+=" 817"
 fi
@@ -144,6 +144,13 @@ check_swap_layouts_support()
                skip "Does not support layout lock."
 }
 
+check_swap_layout_no_dom()
+{
+       local FOLDER=$1
+       local SUPP=$(lfs getstripe $FOLDER | grep "pattern:       mdt" | wc -l)
+       [ $SUPP -eq 0 ] || skip "layout swap does not support DOM files so far"
+}
+
 check_and_setup_lustre
 DIR=${DIR:-$MOUNT}
 assert_DIR
@@ -1780,17 +1787,24 @@ run_test 27m "create file while OST0 was full"
 # OSCs keep a NOSPC flag that will be reset after ~5s (qos_maxage)
 # if the OST isn't full anymore.
 reset_enospc() {
-       local OSTIDX=${1:-""}
+       local ostidx=${1:-""}
+       local delay
+       local ready
+       local get_prealloc
 
        local list=$(comma_list $(osts_nodes))
-       [ "$OSTIDX" ] && list=$(facet_host ost$((OSTIDX + 1)))
+       [ "$ostidx" ] && list=$(facet_host ost$((ostidx + 1)))
 
        do_nodes $list lctl set_param fail_loc=0
-       sync    # initiate all OST_DESTROYs from MDS to OST
-       sleep_maxage
+       wait_delete_completed   # initiate all OST_DESTROYs from MDS to OST
+       delay=$(do_facet $SINGLEMDS lctl get_param -n lov.*.qos_maxage |
+               awk '{print $1 * 2;exit;}')
+       get_prealloc="$LCTL get_param -n osc.*MDT*.prealloc_status |
+                       grep -v \"^0$\""
+       wait_update_facet $SINGLEMDS "$get_prealloc" "" $delay
 }
 
-exhaust_precreations() {
+__exhaust_precreations() {
        local OSTIDX=$1
        local FAILLOC=$2
        local FAILIDX=${3:-$OSTIDX}
@@ -1821,14 +1835,19 @@ exhaust_precreations() {
        createmany -o $DIR/$tdir/${OST}/f $next_id $((last_id - next_id + 2))
        do_facet $mfacet lctl get_param osp.$mdtosc_proc2.prealloc*
        do_facet $ofacet lctl set_param fail_loc=$FAILLOC
+}
+
+exhaust_precreations() {
+       __exhaust_precreations $1 $2 $3
        sleep_maxage
 }
 
 exhaust_all_precreations() {
        local i
        for (( i=0; i < OSTCOUNT; i++ )) ; do
-               exhaust_precreations $i $1 -1
+               __exhaust_precreations $i $1 -1
        done
+       sleep_maxage
 }
 
 test_27n() {
@@ -2600,6 +2619,7 @@ test_27G() { #LU-10629
        local ostrange="0 0 1"
 
        test_mkdir $DIR/$tdir
+       touch $DIR/$tdir/$tfile.nopool
        pool_add $POOL || error "pool_add failed"
        pool_add_targets $POOL $ostrange || error "pool_add_targets failed"
        $LFS setstripe -p $POOL $DIR/$tdir
@@ -2607,14 +2627,18 @@ test_27G() { #LU-10629
        local pool=$($LFS getstripe -p $DIR/$tdir)
 
        [ "$pool" = "$POOL" ] || error "Striping failed got '$pool' not '$POOL'"
+       touch $DIR/$tdir/$tfile.default
+       $LFS setstripe -E 1M --pool $POOL -c 1 -E eof -c 1 $DIR/$tdir/$tfile.pfl
+       $LFS find $DIR/$tdir -type f --pool $POOL
+       local found=$($LFS find $DIR/$tdir -type f --pool $POOL | wc -l)
+       [[ "$found" == "2" ]] ||
+               error "found $found != 2 files in '$DIR/$tdir' in '$POOL'"
 
        $LFS setstripe -d $DIR/$tdir
 
-       pool=$($LFS getstripe -p $DIR/$tdir)
+       pool=$($LFS getstripe -p -d $DIR/$tdir)
 
-       rmdir $DIR/$tdir
-
-       [ -z "$pool" ] || error "'$pool' is not empty"
+       [[ "$pool" != "$POOL" ]] || error "$DIR/$tdir is still '$pool'"
 }
 run_test 27G "Clear OST pool from stripe"
 
@@ -3810,7 +3834,7 @@ test_33h() {
        done
 
        local failed=0
-       for i in {1..50}; do
+       for i in {1..250}; do
                for fname in $(mktemp -u $DIR/$tdir/.$tfile.XXXXXX) \
                             $(mktemp $DIR/$tdir/$tfile.XXXXXXXX); do
                        touch $fname  || error "touch $fname failed"
@@ -3822,7 +3846,7 @@ test_33h() {
                done
        done
        echo "$failed MDT index mismatches"
-       (( failed < 4 )) || error "MDT index mismatch $failed times"
+       (( failed < 20 )) || error "MDT index mismatch $failed times"
 
 }
 run_test 33h "temp file is located on the same MDT as target"
@@ -4856,6 +4880,8 @@ test_43A() { # was test_43
 
        $DIR/$tdir/$tfile && error "execute $DIR/$tdir/$tfile succeeded" || true
        kill -USR1 $pid
+       # Wait for multiop to exit
+       wait $pid
 }
 run_test 43A "execution of file opened for write should return -ETXTBSY"
 
@@ -5105,6 +5131,27 @@ test_48e() { # bug 4134
 }
 run_test 48e "Access to recreated parent subdir (should return errors)"
 
+test_48f() {
+       [[ $MDS1_VERSION -ge $(version_code 2.13.55) ]] ||
+               skip "need MDS >= 2.13.55"
+       [[ $MDSCOUNT -ge 2 ]] || skip "needs >= 2 MDTs"
+       [[ "$(facet_host mds1)" != "$(facet_host mds2)" ]] ||
+               skip "needs different host for mdt1 mdt2"
+       [[ $(facet_fstype mds1) == ldiskfs ]] || skip "ldiskfs only"
+
+       $LFS mkdir -i0 $DIR/$tdir
+       $LFS mkdir -i 1 $DIR/$tdir/sub1 $DIR/$tdir/sub2 $DIR/$tdir/sub3
+
+       for d in sub1 sub2 sub3; do
+               #define OBD_FAIL_OSD_REF_DEL    0x19c
+               do_facet mds1 $LCTL set_param fail_loc=0x8000019c
+               rm -rf $DIR/$tdir/$d && error "rm $d should fail"
+       done
+
+       rm -d --interactive=never $DIR/$tdir || error "rm $tdir fail"
+}
+run_test 48f "non-zero nlink dir unlink won't LBUG()"
+
 test_49() { # LU-1030
        [ $PARALLEL == "yes" ] && skip "skip parallel run"
        remote_ost_nodsh && skip "remote OST with nodsh"
@@ -5895,7 +5942,7 @@ test_56ob() {
        cmd="$LFS find $dir -ctime +1s -type f"
        nums=$($cmd | wc -l)
        (( $nums == $count * 2 + 1)) ||
-               error "'$cmd' wrong: found $nums, expected $((expected*2+1))"
+               error "'$cmd' wrong: found $nums, expected $((count * 2 + 1))"
 }
 run_test 56ob "check lfs find -atime -mtime -ctime with units"
 
@@ -6251,14 +6298,15 @@ test_56rb() {
        test_mkdir -p $dir || error "failed to mkdir $dir"
        $LFS setstripe -c 1 -i 0 $dir/$tfile ||
                error "failed to setstripe $dir/$tfile"
+       mdt_idx=$($LFS getdirstripe -i $dir)
        dd if=/dev/zero of=$dir/$tfile bs=1M count=1
 
        stack_trap "rm -f $tmp" EXIT
-       $LFS find --size +100K --ost 0 $dir 2>&1 | tee $tmp
-       [ -z "$(cat $tmp | grep "obd_uuid: ")" ] ||
+       $LFS find --size +100K --ost 0 $dir |& tee $tmp
+       ! grep -q obd_uuid $tmp ||
                error "failed to find --size +100K --ost 0 $dir"
-       $LFS find --size +100K --mdt $mdt_idx $dir 2>&1 | tee $tmp
-       [ -z "$(cat $tmp | grep "obd_uuid: ")" ] ||
+       $LFS find --size +100K --mdt $mdt_idx $dir |& tee $tmp
+       ! grep -q obd_uuid $tmp ||
                error "failed to find --size +100K --mdt $mdt_idx $dir"
 }
 run_test 56rb "check lfs find --size --ost/--mdt works"
@@ -6784,6 +6832,24 @@ test_56wd() {
 }
 run_test 56wd "check lfs_migrate --rsync and --no-rsync work"
 
+test_56we() {
+       local td=$DIR/$tdir
+       local tf=$td/$tfile
+
+       test_mkdir $td || error "cannot create $td"
+       touch $tf || error "cannot touch $tf"
+
+       echo -n "Make sure --non-direct|-D works..."
+       $LFS_MIGRATE -y --non-direct -v $tf 2>&1 |
+               grep -q "lfs migrate --non-direct" ||
+               error "--non-direct option cannot work correctly"
+       $LFS_MIGRATE -y -D -v $tf 2>&1 |
+               grep -q "lfs migrate -D" ||
+               error "-D option cannot work correctly"
+       echo "done."
+}
+run_test 56we "check lfs_migrate --non-direct|-D support"
+
 test_56x() {
        [[ $OSTCOUNT -lt 2 ]] && skip_env "needs >= 2 OSTs"
        check_swap_layouts_support
@@ -7651,7 +7717,7 @@ test_60g() {
 
                do_facet mds$index $LCTL set_param fail_loc=0x8000019a \
                        > /dev/null
-               usleep 100
+               sleep 0.01
        done
 
        kill -9 $pid
@@ -7804,18 +7870,25 @@ test_64c() {
 }
 run_test 64c "verify grant shrink"
 
+import_param() {
+       local tgt=$1
+       local param=$2
+
+       $LCTL get_param osc.$tgt.import | awk "/$param/ { print \$2 }"
+}
+
 # this does exactly what osc_request.c:osc_announce_cached() does in
 # order to calculate max amount of grants to ask from server
 want_grant() {
        local tgt=$1
 
-       local nrpages=$($LCTL get_param -n osc.${tgt}.max_pages_per_rpc)
-       local rpc_in_flight=$($LCTL get_param -n osc.${tgt}.max_rpcs_in_flight)
+       local nrpages=$($LCTL get_param -n osc.$tgt.max_pages_per_rpc)
+       local rpc_in_flight=$($LCTL get_param -n osc.$tgt.max_rpcs_in_flight)
 
-       ((rpc_in_flight ++));
+       ((rpc_in_flight++));
        nrpages=$((nrpages * rpc_in_flight))
 
-       local dirty_max_pages=$($LCTL get_param -n osc.${tgt}.max_dirty_mb)
+       local dirty_max_pages=$($LCTL get_param -n osc.$tgt.max_dirty_mb)
 
        dirty_max_pages=$((dirty_max_pages * 1024 * 1024 / PAGE_SIZE))
 
@@ -7823,13 +7896,11 @@ want_grant() {
        local undirty=$((nrpages * PAGE_SIZE))
 
        local max_extent_pages
-       max_extent_pages=$($LCTL get_param osc.${tgt}.import |
-           grep grant_max_extent_size | awk '{print $2}')
+       max_extent_pages=$(import_param $tgt grant_max_extent_size)
        max_extent_pages=$((max_extent_pages / PAGE_SIZE))
        local nrextents=$(((nrpages + max_extent_pages - 1) / max_extent_pages))
        local grant_extent_tax
-       grant_extent_tax=$($LCTL get_param osc.${tgt}.import |
-           grep grant_extent_tax | awk '{print $2}')
+       grant_extent_tax=$(import_param $tgt grant_extent_tax)
 
        undirty=$((undirty + nrextents * grant_extent_tax))
 
@@ -7843,56 +7914,171 @@ grant_chunk() {
        local max_brw_size
        local grant_extent_tax
 
-       max_brw_size=$($LCTL get_param osc.${tgt}.import |
-           grep max_brw_size | awk '{print $2}')
+       max_brw_size=$(import_param $tgt max_brw_size)
 
-       grant_extent_tax=$($LCTL get_param osc.${tgt}.import |
-           grep grant_extent_tax | awk '{print $2}')
+       grant_extent_tax=$(import_param $tgt grant_extent_tax)
 
        echo $(((max_brw_size + grant_extent_tax) * 2))
 }
 
 test_64d() {
-       [ $OST1_VERSION -lt $(version_code 2.10.56) ] &&
+       [ $OST1_VERSION -ge $(version_code 2.10.56) ] ||
                skip "OST < 2.10.55 doesn't limit grants enough"
 
-       local tgt=$($LCTL dl | grep "0000-osc-[^mM]" | awk '{print $4}')
-       local file=$DIR/$tfile
+       local tgt=$($LCTL dl | awk '/OST0000-osc-[^mM]/ { print $4 }')
 
-       [[ $($LCTL get_param osc.${tgt}.import |
-            grep "connect_flags:.*grant_param") ]] ||
+       [[ "$($LCTL get_param osc.${tgt}.import)" =~ "grant_param" ]] ||
                skip "no grant_param connect flag"
 
-       local olddebug=$($LCTL get_param -n debug 2> /dev/null)
+       local olddebug="$($LCTL get_param -n debug 2> /dev/null)"
+
+       $LCTL set_param -n -n debug="$OLDDEBUG" || true
+       stack_trap "$LCTL set_param -n debug='$olddebug'" EXIT
 
-       $LCTL set_param debug="$OLDDEBUG" 2> /dev/null || true
 
        local max_cur_granted=$(($(want_grant $tgt) + $(grant_chunk $tgt)))
-       stack_trap "rm -f $file" EXIT
+       stack_trap "rm -f $DIR/$tfile && wait_delete_completed" EXIT
 
-       $LFS setstripe $file -i 0 -c 1
-       dd if=/dev/zero of=$file bs=1M count=1000 &
+       $LFS setstripe $DIR/$tfile -i 0 -c 1
+       dd if=/dev/zero of=$DIR/$tfile bs=1M count=1000 &
        ddpid=$!
 
-       while true
-       do
-               local cur_grant=$($LCTL get_param -n osc.${tgt}.cur_grant_bytes)
-               if [[ $cur_grant -gt $max_cur_granted ]]
-               then
+       while kill -0 $ddpid; do
+               local cur_grant=$($LCTL get_param -n osc.$tgt.cur_grant_bytes)
+
+               if [[ $cur_grant -gt $max_cur_granted ]]; then
                        kill $ddpid
                        error "cur_grant $cur_grant > $max_cur_granted"
                fi
-               kill -0 $ddpid
-               [[ $? -ne 0 ]] && break;
-               sleep 2
-       done
 
-       rm -f $DIR/$tfile
-       wait_delete_completed
-       $LCTL set_param debug="$olddebug" 2> /dev/null || true
+               sleep 1
+       done
 }
 run_test 64d "check grant limit exceed"
 
+check_grants() {
+       local tgt=$1
+       local expected=$2
+       local msg=$3
+       local cur_grants=$($LCTL get_param -n osc.$tgt.cur_grant_bytes)
+
+       ((cur_grants == expected)) ||
+               error "$msg: grants mismatch: $cur_grants, expected $expected"
+}
+
+round_up_p2() {
+       echo $((($1 + $2 - 1) & ~($2 - 1)))
+}
+
+test_64e() {
+       [ $PARALLEL == "yes" ] && skip "skip parallel run"
+       [ $OST1_VERSION -ge $(version_code 2.11.56) ] ||
+               skip "Need OSS version at least 2.11.56"
+
+       # Remount client to reset grant
+       remount_client $MOUNT || error "failed to remount client"
+       local osc_tgt="$FSNAME-OST0000-osc-$($LFS getname -i $DIR)"
+
+       local init_grants=$(import_param $osc_tgt initial_grant)
+
+       check_grants $osc_tgt $init_grants "init grants"
+
+       local extent_tax=$(import_param $osc_tgt grant_extent_tax)
+       local max_brw_size=$(import_param $osc_tgt max_brw_size)
+       local gbs=$(import_param $osc_tgt grant_block_size)
+
+       # write random number of bytes from max_brw_size / 4 to max_brw_size
+       local write_bytes=$(shuf -i $((max_brw_size / 4))-$max_brw_size -n 1)
+       # align for direct io
+       write_bytes=$(round_up_p2 $write_bytes PAGE_SIZE)
+       # round to grant consumption unit
+       local wb_round_up=$(round_up_p2 $write_bytes gbs)
+
+       local grants=$((wb_round_up + extent_tax))
+
+       $LFS setstripe -c 1 -i 0 $DIR/$tfile  || error "lfs setstripe failed"
+
+       # define OBD_FAIL_TGT_NO_GRANT 0x725
+       # make the server not grant more back
+       do_facet ost1 $LCTL set_param fail_loc=0x725
+       dd if=/dev/zero of=$DIR/$tfile bs=$write_bytes count=1 oflag=direct
+
+       do_facet ost1 $LCTL set_param fail_loc=0
+
+       check_grants $osc_tgt $((init_grants - grants)) "dio w/o grant alloc"
+
+       rm -f $DIR/$tfile || error "rm failed"
+
+       # Remount client to reset grant
+       remount_client $MOUNT || error "failed to remount client"
+       osc_tgt="$FSNAME-OST0000-osc-$($LFS getname -i $DIR)"
+
+       $LFS setstripe -c 1 -i 0 $DIR/$tfile || error "lfs setstripe failed"
+
+       # define OBD_FAIL_TGT_NO_GRANT 0x725
+       # make the server not grant more back
+       do_facet ost1 $LCTL set_param fail_loc=0x725
+       $MULTIOP $DIR/$tfile "oO_WRONLY:w${write_bytes}yc"
+       do_facet ost1 $LCTL set_param fail_loc=0
+
+       check_grants $osc_tgt $((init_grants - grants)) "buf io w/o grant alloc"
+}
+run_test 64e "check grant consumption (no grant allocation)"
+
+test_64f() {
+       [ $PARALLEL == "yes" ] && skip "skip parallel run"
+
+       # Remount client to reset grant
+       remount_client $MOUNT || error "failed to remount client"
+       local osc_tgt="$FSNAME-OST0000-osc-$($LFS getname -i $DIR)"
+
+       local init_grants=$(import_param $osc_tgt initial_grant)
+       local extent_tax=$(import_param $osc_tgt grant_extent_tax)
+       local max_brw_size=$(import_param $osc_tgt max_brw_size)
+       local gbs=$(import_param $osc_tgt grant_block_size)
+       local chunk=$(grant_chunk $osc_tgt)
+
+       # write random number of bytes from max_brw_size / 4 to max_brw_size
+       local write_bytes=$(shuf -i $((max_brw_size / 4))-$max_brw_size -n 1)
+       # align for direct io
+       write_bytes=$(round_up_p2 $write_bytes PAGE_SIZE)
+       # round to grant consumption unit
+       local wb_round_up=$(round_up_p2 $write_bytes gbs)
+
+       local grants=$((wb_round_up + extent_tax))
+
+       $LFS setstripe -c 1 -i 0 $DIR/$tfile || error "lfs setstripe failed"
+       dd if=/dev/zero of=$DIR/$tfile bs=$write_bytes count=1 oflag=direct ||
+               error "error writing to $DIR/$tfile"
+
+       check_grants $osc_tgt $((init_grants - grants + chunk)) \
+               "direct io with grant allocation"
+
+       rm -f $DIR/$tfile || error "rm failed"
+
+       # Remount client to reset grant
+       remount_client $MOUNT || error "failed to remount client"
+       osc_tgt="$FSNAME-OST0000-osc-$($LFS getname -i $DIR)"
+
+       $LFS setstripe -c 1 -i 0 $DIR/$tfile || error "lfs setstripe failed"
+
+       local cmd="oO_WRONLY:w${write_bytes}_yc"
+
+       $MULTIOP $DIR/$tfile $cmd &
+       MULTIPID=$!
+       sleep 1
+
+       check_grants $osc_tgt $((init_grants - grants)) \
+               "buffered io, not write rpc"
+
+       kill -USR1 $MULTIPID
+       wait
+
+       check_grants $osc_tgt $((init_grants - grants + chunk)) \
+               "buffered io, one RPC"
+}
+run_test 64f "check grant consumption (with grant allocation)"
+
 # bug 1414 - set/get directories' stripe info
 test_65a() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run"
@@ -8444,34 +8630,45 @@ test_74c() {
 }
 run_test 74c "ldlm_lock_create error path, (shouldn't LBUG)"
 
-num_inodes() {
-       awk '/lustre_inode_cache/ {print $2; exit}' /proc/slabinfo
+slab_lic=/sys/kernel/slab/lustre_inode_cache
+num_objects() {
+       [ -f $slab_lic/shrink ] && echo 1 > $slab_lic/shrink
+       [ -f $slab_lic/objects ] && awk '{ print $1 }' $slab_lic/objects ||
+               awk '/lustre_inode_cache/ { print $2; exit }' /proc/slabinfo
 }
 
-test_76() { # Now for bug 20433, added originally in bug 1443
+test_76() { # Now for b=20433, added originally in b=1443
        [ $PARALLEL == "yes" ] && skip "skip parallel run"
 
        cancel_lru_locks osc
+       # there may be some slab objects cached per core
        local cpus=$(getconf _NPROCESSORS_ONLN 2>/dev/null)
-       local before=$(num_inodes)
+       local before=$(num_objects)
        local count=$((512 * cpus))
-       [ "$SLOW" = "no" ] && count=$((64 * cpus))
+       [ "$SLOW" = "no" ] && count=$((128 * cpus))
+       local margin=$((count / 10))
+       if [[ -f $slab_lic/aliases ]]; then
+               local aliases=$(cat $slab_lic/aliases)
+               (( aliases > 0 )) && margin=$((margin * aliases))
+       fi
 
-       echo "before inodes: $before"
+       echo "before slab objects: $before"
        for i in $(seq $count); do
                touch $DIR/$tfile
                rm -f $DIR/$tfile
        done
        cancel_lru_locks osc
-       local after=$(num_inodes)
-       echo "after inodes: $after"
-       while (( after > before + 8 * ${cpus:-1} )); do
+       local after=$(num_objects)
+       echo "created: $count, after slab objects: $after"
+       # shared slab counts are not very accurate, allow significant margin
+       # the main goal is that the cache growth is not permanently > $count
+       while (( after > before + margin )); do
                sleep 1
-               after=$(num_inodes)
+               after=$(num_objects)
                wait=$((wait + 1))
-               (( wait % 5 == 0 )) && echo "wait $wait seconds inodes: $after"
-               if (( wait > 30 )); then
-                       error "inode slab grew from $before to $after"
+               (( wait % 5 == 0 )) && echo "wait $wait seconds objects: $after"
+               if (( wait > 60 )); then
+                       error "inode slab grew from $before+$margin to $after"
                fi
        done
 }
@@ -8734,9 +8931,8 @@ test_77k() { # LU-10906
        local i
 
        [ "$ORIG_CSUM" ] || ORIG_CSUM=$(eval $get_checksum)
-       stack_trap "wait_update $HOSTNAME '$get_checksum' $ORIG_CSUM" EXIT
-       stack_trap "do_facet mgs $LCTL set_param -P $cksum_param=$ORIG_CSUM" \
-               EXIT
+       stack_trap "wait_update $HOSTNAME '$get_checksum' $ORIG_CSUM || true"
+       stack_trap "do_facet mgs $LCTL set_param -P $cksum_param=$ORIG_CSUM"
 
        for i in 0 1; do
                do_facet mgs $LCTL set_param -P $cksum_param=$i ||
@@ -8959,28 +9155,6 @@ test_81b() { # LU-456
 }
 run_test 81b "OST should return -ENOSPC when retry still fails ======="
 
-test_82() { # LU-1031
-       dd if=/dev/zero of=$DIR/$tfile bs=1M count=10
-       local gid1=14091995
-       local gid2=16022000
-
-       multiop_bg_pause $DIR/$tfile OG${gid1}_g${gid1}c || return 1
-       local MULTIPID1=$!
-       multiop_bg_pause $DIR/$tfile O_G${gid2}r10g${gid2}c || return 2
-       local MULTIPID2=$!
-       kill -USR1 $MULTIPID2
-       sleep 2
-       if [[ `ps h -o comm -p $MULTIPID2` == "" ]]; then
-               error "First grouplock does not block second one"
-       else
-               echo "Second grouplock blocks first one"
-       fi
-       kill -USR1 $MULTIPID1
-       wait $MULTIPID1
-       wait $MULTIPID2
-}
-run_test 82 "Basic grouplock test"
-
 test_99() {
        [ -z "$(which cvs 2>/dev/null)" ] && skip_env "could not find cvs"
 
@@ -12913,10 +13087,8 @@ test_133h() {
                skip "Need MDS version at least 2.9.54"
 
        local facet
-
        for facet in client mds1 ost1; do
                # Get the list of files that are missing the terminating newline
-               #local missing=($(do_facet $facet \
                local plist=$(do_facet $facet
                        $LCTL list_param -FR '*' | grep '=' | tr -d =)
                local ent
@@ -12925,8 +13097,10 @@ test_133h() {
                                awk -v FS='\v' -v RS='\v\v' \
                                "'END { if(NR>0 && \\\$NF !~ /.*\\\n\$/) \
                                        print FILENAME}'" 2>/dev/null)
-                       [ -z $missing ] ||
-                               error "files do not end with newline: $missing"
+                       [ -z $missing ] || {
+                               do_facet $facet $LCTL get_param $ent | od -An -tx1
+                               error "file does not end with newline: $facet-$ent"
+                       }
                done
        done
 }
@@ -13487,10 +13661,19 @@ test_154A() {
        [ -z "$fid" ] && error "path2fid unable to get $tf FID"
 
        # check that we get the same pathname back
-       local found=$($LFS fid2path $MOUNT "$fid")
-       [ -z "$found" ] && error "fid2path unable to get '$fid' path"
-       [ "$found" == "$tf" ] ||
-               error "fid2path($fid=path2fid($tf)) = $found != $tf"
+       local rootpath
+       local found
+       for rootpath in "$MOUNT" "$MOUNT///" "$MOUNT/$tfile"; do
+               echo "$rootpath $fid"
+               found=$($LFS fid2path $rootpath "$fid")
+               [ -z "$found" ] && error "fid2path unable to get '$fid' path"
+               [ "$found" == "$tf" ] || error "fid2path $found != $tf"
+       done
+
+       # check wrong root path format
+       rootpath=$MOUNT"_wrong"
+       found=$($LFS fid2path $rootpath "$fid")
+       [ -z "$found" ] || error "should fail ($rootpath != $MOUNT)"
 }
 run_test 154A "lfs path2fid and fid2path basic checks"
 
@@ -14830,6 +15013,71 @@ test_160k() {
 }
 run_test 160k "Verify that changelog records are not lost"
 
+# Verifies that a file passed as a parameter has recently had an operation
+# performed on it that has generated an MTIME changelog which contains the
+# correct parent FID. As files might reside on a different MDT from the
+# parent directory in DNE configurations, the FIDs are translated to paths
+# before being compared, which should be identical
+compare_mtime_changelog() {
+       local file="${1}"
+       local mdtidx
+       local mtime
+       local cl_fid
+       local pdir
+       local dir
+
+       mdtidx=$($LFS getstripe --mdt-index $file)
+       mdtidx=$(printf "%04x" $mdtidx)
+
+       # Obtain the parent FID from the MTIME changelog
+       mtime=$($LFS changelog $FSNAME-MDT$mdtidx | tail -n 1 | grep MTIME)
+       [ -z "$mtime" ] && error "MTIME changelog not recorded"
+
+       cl_fid=$(sed -e 's/.* p=//' -e 's/ .*//' <<<$mtime)
+       [ -z "$cl_fid" ] && error "parent FID not present"
+
+       # Verify that the path for the parent FID is the same as the path for
+       # the test directory
+       pdir=$($LFS fid2path $MOUNT "$cl_fid")
+
+       dir=$(dirname $1)
+
+       [[ "${pdir%/}" == "$dir" ]] ||
+               error "MTIME changelog parent FID is wrong, expected $dir, got $pdir"
+}
+
+test_160l() {
+       [ $PARALLEL == "yes" ] && skip "skip parallel run"
+
+       remote_mds_nodsh && skip "remote MDS with nodsh"
+       [[ $MDS1_VERSION -ge $(version_code 2.13.55) ]] ||
+               skip "Need MDS version at least 2.13.55"
+
+       local cl_user
+
+       changelog_register || error "changelog_register failed"
+       cl_user="${CL_USERS[$SINGLEMDS]%% *}"
+
+       changelog_users $SINGLEMDS | grep -q $cl_user ||
+               error "User '$cl_user' not found in changelog_users"
+
+       # Clear some types so that MTIME changelogs are generated
+       changelog_chmask "-CREAT"
+       changelog_chmask "-CLOSE"
+
+       test_mkdir $DIR/$tdir || error "failed to mkdir $DIR/$tdir"
+
+       # Test CL_MTIME during setattr
+       touch $DIR/$tdir/$tfile
+       compare_mtime_changelog $DIR/$tdir/$tfile
+
+       # Test CL_MTIME during close
+       dd if=/dev/urandom of=$DIR/$tdir/${tfile}_2 bs=1M count=64 ||
+               error "cannot create file $DIR/$tdir/${tfile}_2"
+       compare_mtime_changelog $DIR/$tdir/${tfile}_2
+}
+run_test 160l "Verify that MTIME changelog records contain the parent FID"
+
 test_161a() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run"
 
@@ -15539,7 +15787,8 @@ obdecho_test() {
 test_180a() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run"
 
-       if ! module_loaded obdecho; then
+       if ! [ -d /sys/fs/lustre/echo_client ] &&
+          ! module_loaded obdecho; then
                load_module obdecho/obdecho &&
                        stack_trap "rmmod obdecho" EXIT ||
                        error "unable to load obdecho on client"
@@ -15750,6 +15999,7 @@ test_184c() {
        local cmpn_arg=$(cmp -n 2>&1 | grep "invalid option")
        [ -n "$cmpn_arg" ] && skip_env "cmp does not support -n"
        check_swap_layouts_support
+       check_swap_layout_no_dom $DIR
 
        local dir0=$DIR/$tdir/$testnum
        mkdir -p $dir0 || error "creating dir $dir0"
@@ -15797,6 +16047,7 @@ run_test 184c "Concurrent write and layout swap"
 
 test_184d() {
        check_swap_layouts_support
+       check_swap_layout_no_dom $DIR
        [ -z "$(which getfattr 2>/dev/null)" ] &&
                skip_env "no getfattr command"
 
@@ -15833,6 +16084,7 @@ test_184e() {
        [[ $MDS1_VERSION -ge $(version_code 2.6.94) ]] ||
                skip "Need MDS version at least 2.6.94"
        check_swap_layouts_support
+       check_swap_layout_no_dom $DIR
        [ -z "$(which getfattr 2>/dev/null)" ] &&
                skip_env "no getfattr command"
 
@@ -16323,16 +16575,31 @@ test_205a() { # Job stats
 }
 run_test 205a "Verify job stats"
 
-# LU-13117
+# LU-13117, LU-13597
 test_205b() {
+       job_stats="mdt.*.job_stats"
+       $LCTL set_param $job_stats=clear
        $LCTL set_param jobid_var=USER jobid_name="%e.%u"
        env -i USERTESTJOBSTATS=foolish touch $DIR/$tfile.1
-       do_facet $SINGLEMDS $LCTL get_param mdt.*.job_stats |
-               grep job_id: | grep foolish &&
+       do_facet $SINGLEMDS $LCTL get_param $job_stats |
+               grep "job_id:.*foolish" &&
                        error "Unexpected jobid found"
-       true
+       do_facet $SINGLEMDS $LCTL get_param $job_stats |
+               grep "open:.*min.*max.*sum" ||
+                       error "wrong job_stats format found"
+}
+run_test 205b "Verify job stats jobid and output format"
+
+# LU-13733
+test_205c() {
+       $LCTL set_param llite.*.stats=0
+       dd if=/dev/zero of=$DIR/$tfile.1 bs=4k count=1
+       $LCTL get_param llite.*.stats
+       $LCTL get_param llite.*.stats | grep \
+               "write_bytes *1 samples \[bytes\] 4096 4096 4096 16777216" ||
+                       error "wrong client stats format found"
 }
-run_test 205b "Verify job stats jobid parsing"
+run_test 205c "Verify client stats format"
 
 # LU-1480, LU-1773 and LU-1657
 test_206() {
@@ -16440,6 +16707,8 @@ test_209() {
        sync; sleep 5; sync;
 
        echo 3 > /proc/sys/vm/drop_caches
+       [ -f /sys/kernel/slab/ptlrpc_cache/shrink ] &&
+               echo 1 > /sys/kernel/slab/ptlrpc_cache/shrink
        req_before=$(awk '/ptlrpc_cache / { print $2 }' /proc/slabinfo)
 
        # open/close 500 times
@@ -16448,6 +16717,8 @@ test_209() {
        done
 
        echo 3 > /proc/sys/vm/drop_caches
+       [ -f /sys/kernel/slab/ptlrpc_cache/shrink ] &&
+               echo 1 > /sys/kernel/slab/ptlrpc_cache/shrink
        req_after=$(awk '/ptlrpc_cache / { print $2 }' /proc/slabinfo)
 
        echo "before: $req_before, after: $req_after"
@@ -16457,6 +16728,27 @@ test_209() {
 }
 run_test 209 "read-only open/close requests should be freed promptly"
 
+test_210() {
+       local pid
+
+       $MULTIOP $DIR/$tfile oO_CREAT:O_RDWR:eW_E+eUc &
+       pid=$!
+       sleep 1
+
+       $LFS getstripe $DIR/$tfile
+       kill -USR1 $pid
+       wait $pid || error "multiop failed"
+
+       $MULTIOP $DIR/$tfile oO_RDONLY:eR_E+eUc &
+       pid=$!
+       sleep 1
+
+       $LFS getstripe $DIR/$tfile
+       kill -USR1 $pid
+       wait $pid || error "multiop failed"
+}
+run_test 210 "lfs getstripe does not break leases"
+
 test_212() {
        size=`date +%s`
        size=$((size % 8192 + 1))
@@ -17020,6 +17312,34 @@ test_226b () {
 }
 run_test 226b "call path2fid and fid2path on files of all type under remote dir"
 
+test_226c () {
+       [ $MDSCOUNT -lt 2 ] && skip_env "needs >= 2 MDTs"
+       [[ $MDS1_VERSION -ge $(version_code 2.13.55) ]] ||
+               skip "Need MDS version at least 2.13.55"
+
+       local submnt=/mnt/submnt
+       local srcfile=/etc/passwd
+       local dstfile=$submnt/passwd
+       local path
+       local fid
+
+       rm -rf $DIR/$tdir
+       rm -rf $submnt
+       $LFS setdirstripe -c -1 -i 1 $DIR/$tdir ||
+               error "create remote directory failed"
+       mkdir -p $submnt || error "create $submnt failed"
+       $MOUNT_CMD $MGSNID:/$FSNAME/$tdir $submnt ||
+               error "mount $submnt failed"
+       stack_trap "umount $submnt" EXIT
+
+       cp $srcfile $dstfile
+       fid=$($LFS path2fid $dstfile)
+       path=$($LFS fid2path $submnt "$fid")
+       [ "$path" = "$dstfile" ] ||
+               error "fid2path $submnt $fid failed ($path != $dstfile)"
+}
+run_test 226c "call path2fid and fid2path under remote dir with subdir mount"
+
 # LU-1299 Executing or running ldd on a truncated executable does not
 # cause an out-of-memory condition.
 test_227() {
@@ -17717,7 +18037,7 @@ run_test 230i "lfs migrate -m tolerates trailing slashes"
 
 test_230j() {
        [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs"
-       [ $MDS1_VERSION -lt $(version_code 2.11.52) ] &&
+       [ $MDS1_VERSION -lt $(version_code 2.13.52) ] &&
                skip "Need MDS version at least 2.11.52"
 
        $LFS mkdir -m 0 -c 1 $DIR/$tdir || error "mkdir $tdir failed"
@@ -17725,7 +18045,7 @@ test_230j() {
                error "create $tfile failed"
        cat /etc/passwd > $DIR/$tdir/$tfile
 
-       $LFS migrate -m 1 $DIR/$tdir
+       $LFS migrate -m 1 $DIR/$tdir || error "migrate failed"
 
        cmp /etc/passwd $DIR/$tdir/$tfile ||
                error "DoM file mismatch after migration"
@@ -17864,6 +18184,197 @@ test_230n() {
 }
 run_test 230n "Dir migration with mirrored file"
 
+test_230o() {
+       [ $MDSCOUNT -ge 2 ] || skip "needs >= 2 MDTs"
+       [ $MDS1_VERSION -ge $(version_code 2.13.52) ] ||
+               skip "Need MDS version at least 2.13.52"
+
+       local mdts=$(comma_list $(mdts_nodes))
+       local timeout=100
+
+       local restripe_status
+       local delta
+       local i
+       local j
+
+       [[ $(facet_fstype mds1) == zfs ]] && timeout=300
+
+       # in case "crush" hash type is not set
+       do_nodes $mdts "$LCTL set_param lod.*.mdt_hash=crush"
+
+       restripe_status=$(do_facet mds1 $LCTL get_param -n \
+                          mdt.*MDT0000.enable_dir_restripe)
+       do_nodes $mdts "$LCTL set_param mdt.*.enable_dir_restripe=1"
+       stack_trap "do_nodes $mdts $LCTL set_param \
+                   mdt.*.enable_dir_restripe=$restripe_status"
+
+       mkdir $DIR/$tdir
+       createmany -m $DIR/$tdir/f 100 ||
+               error "create files under remote dir failed $i"
+       createmany -d $DIR/$tdir/d 100 ||
+               error "create dirs under remote dir failed $i"
+
+       for i in $(seq 2 $MDSCOUNT); do
+               do_nodes $mdts "$LCTL set_param mdt.*.md_stats=clear > /dev/null"
+               $LFS setdirstripe -c $i $DIR/$tdir ||
+                       error "split -c $i $tdir failed"
+               wait_update $HOSTNAME \
+                       "$LFS getdirstripe -H $DIR/$tdir" "crush" $timeout ||
+                       error "dir split not finished"
+               delta=$(do_nodes $mdts "lctl get_param -n mdt.*MDT*.md_stats" |
+                       awk '/migrate/ {sum += $2} END { print sum }')
+               echo "$delta files migrated when dir split from $((i - 1)) to $i stripes"
+               # delta is around total_files/stripe_count
+               [ $delta -lt $((200 /(i - 1))) ] ||
+                       error "$delta files migrated"
+       done
+}
+run_test 230o "dir split"
+
+test_230p() {
+       [ $MDSCOUNT -ge 2 ] || skip "needs >= 2 MDTs"
+       [ $MDS1_VERSION -ge $(version_code 2.13.52) ] ||
+               skip "Need MDS version at least 2.13.52"
+
+       local mdts=$(comma_list $(mdts_nodes))
+       local timeout=100
+
+       local restripe_status
+       local delta
+       local i
+       local j
+
+       [[ $(facet_fstype mds1) == zfs ]] && timeout=300
+
+       do_nodes $mdts "$LCTL set_param lod.*.mdt_hash=crush"
+
+       restripe_status=$(do_facet mds1 $LCTL get_param -n \
+                          mdt.*MDT0000.enable_dir_restripe)
+       do_nodes $mdts "$LCTL set_param mdt.*.enable_dir_restripe=1"
+       stack_trap "do_nodes $mdts $LCTL set_param \
+                   mdt.*.enable_dir_restripe=$restripe_status"
+
+       test_mkdir -c $MDSCOUNT -H crush $DIR/$tdir
+       createmany -m $DIR/$tdir/f 100 ||
+               error "create files under remote dir failed $i"
+       createmany -d $DIR/$tdir/d 100 ||
+               error "create dirs under remote dir failed $i"
+
+       for i in $(seq $((MDSCOUNT - 1)) -1 1); do
+               local mdt_hash="crush"
+
+               do_nodes $mdts "$LCTL set_param mdt.*.md_stats=clear > /dev/null"
+               $LFS setdirstripe -c $i $DIR/$tdir ||
+                       error "split -c $i $tdir failed"
+               [ $i -eq 1 ] && mdt_hash="none"
+               wait_update $HOSTNAME \
+                       "$LFS getdirstripe -H $DIR/$tdir" $mdt_hash $timeout ||
+                       error "dir merge not finished"
+               delta=$(do_nodes $mdts "lctl get_param -n mdt.*MDT*.md_stats" |
+                       awk '/migrate/ {sum += $2} END { print sum }')
+               echo "$delta files migrated when dir merge from $((i + 1)) to $i stripes"
+               # delta is around total_files/stripe_count
+               [ $delta -lt $((200 / i)) ] ||
+                       error "$delta files migrated"
+       done
+}
+run_test 230p "dir merge"
+
+test_230q() {
+       [ $MDSCOUNT -ge 2 ] || skip "needs >= 2 MDTs"
+       [ $MDS1_VERSION -ge $(version_code 2.13.52) ] ||
+               skip "Need MDS version at least 2.13.52"
+
+       local mdts=$(comma_list $(mdts_nodes))
+       local saved_threshold=$(do_facet mds1 \
+                       $LCTL get_param -n mdt.*-MDT0000.dir_split_count)
+       local saved_delta=$(do_facet mds1 \
+                       $LCTL get_param -n mdt.*-MDT0000.dir_split_delta)
+       local threshold=100
+       local delta=2
+       local total=0
+       local stripe_count=0
+       local stripe_index
+       local nr_files
+
+       stack_trap "do_nodes $mdts $LCTL set_param \
+                   mdt.*.dir_split_count=$saved_threshold"
+       stack_trap "do_nodes $mdts $LCTL set_param \
+                   mdt.*.dir_split_delta=$saved_delta"
+       stack_trap "do_nodes $mdts $LCTL set_param mdt.*.dir_restripe_nsonly=1"
+       do_nodes $mdts "$LCTL set_param mdt.*.enable_dir_auto_split=1"
+       do_nodes $mdts "$LCTL set_param mdt.*.dir_split_count=$threshold"
+       do_nodes $mdts "$LCTL set_param mdt.*.dir_split_delta=$delta"
+       do_nodes $mdts "$LCTL set_param mdt.*.dir_restripe_nsonly=0"
+       do_nodes $mdts "$LCTL set_param lod.*.mdt_hash=crush"
+
+       $LFS mkdir -i -1 -c 1 $DIR/$tdir || error "mkdir $tdir failed"
+       stripe_index=$($LFS getdirstripe -i $DIR/$tdir)
+
+       while [ $stripe_count -lt $MDSCOUNT ]; do
+               createmany -m $DIR/$tdir/f $total $((threshold * 3 / 2)) ||
+                       error "create sub files failed"
+               stat $DIR/$tdir > /dev/null
+               total=$((total + threshold * 3 / 2))
+               stripe_count=$((stripe_count + delta))
+               [ $stripe_count -gt $MDSCOUNT ] && stripe_count=$MDSCOUNT
+
+               wait_update $HOSTNAME \
+                       "$LFS getdirstripe -c $DIR/$tdir" "$stripe_count" 40 ||
+                       error "stripe count $($LFS getdirstripe -c $DIR/$tdir) != $stripe_count"
+
+               wait_update $HOSTNAME \
+                       "$LFS getdirstripe -H $DIR/$tdir" "crush" 200 ||
+                       error "stripe hash $($LFS getdirstripe -H $DIR/$tdir) != crush"
+
+               nr_files=$($LFS getstripe -m $DIR/$tdir/* |
+                          grep -w $stripe_index | wc -l)
+               echo "$nr_files files on MDT$stripe_index after split"
+               [ $nr_files -lt $((total / (stripe_count - 1))) ] ||
+                       error "$nr_files files on MDT$stripe_index after split"
+
+               nr_files=$(ls $DIR/$tdir | wc -w)
+               [ $nr_files -eq $total ] ||
+                       error "total sub files $nr_files != $total"
+       done
+}
+run_test 230q "dir auto split"
+
+test_230r() {
+       [[ $PARALLEL != "yes" ]] || skip "skip parallel run"
+       [[ $MDSCOUNT -ge 2 ]] || skip_env "needs >= 2 MDTs"
+       [[ $MDS1_VERSION -ge $(version_code 2.13.54) ]] ||
+               skip "Need MDS version at least 2.13.54"
+
+       # maximum amount of local locks:
+       # parent striped dir - 2 locks
+       # new stripe in parent to migrate to - 1 lock
+       # source and target - 2 locks
+       # Total 5 locks for regular file
+       mkdir -p $DIR/$tdir
+       $LFS mkdir -i1 -c2 $DIR/$tdir/dir1
+       touch $DIR/$tdir/dir1/eee
+
+       # create 4 hardlink for 4 more locks
+       # Total: 9 locks > RS_MAX_LOCKS (8)
+       $LFS mkdir -i1 -c1 $DIR/$tdir/dir2
+       $LFS mkdir -i1 -c1 $DIR/$tdir/dir3
+       $LFS mkdir -i1 -c1 $DIR/$tdir/dir4
+       $LFS mkdir -i1 -c1 $DIR/$tdir/dir5
+       ln $DIR/$tdir/dir1/eee $DIR/$tdir/dir2/eee
+       ln $DIR/$tdir/dir1/eee $DIR/$tdir/dir3/eee
+       ln $DIR/$tdir/dir1/eee $DIR/$tdir/dir4/eee
+       ln $DIR/$tdir/dir1/eee $DIR/$tdir/dir5/eee
+
+       cancel_lru_locks mdc
+
+       $LFS migrate -m1 -c1 $DIR/$tdir/dir1 ||
+               error "migrate dir fails"
+
+       rm -rf $DIR/$tdir || error "rm dir failed after migration"
+}
+run_test 230r "migrate with too many local locks"
+
 test_231a()
 {
        # For simplicity this test assumes that max_pages_per_rpc
@@ -18325,7 +18836,7 @@ test_247c() {
        $LFS fid2path $submount $fid && error "fid2path should fail"
        cleanup_247 $submount
 }
-run_test 247c "running fid2path outside root"
+run_test 247c "running fid2path outside subdirectory root"
 
 test_247d() {
        lctl get_param -n mdc.$FSNAME-MDT0000*.import | grep -q subtree ||
@@ -18338,11 +18849,28 @@ test_247d() {
        FILESET="$FILESET/$tdir" mount_client $submount ||
                error "mount $submount failed"
        trap "cleanup_247 $submount" EXIT
-       local fid=$($LFS path2fid $submount/dir1)
-       $LFS fid2path $submount $fid || error "fid2path should succeed"
+
+       local td=$submount/dir1
+       local fid=$($LFS path2fid $td)
+       [ -z "$fid" ] && error "path2fid unable to get $td FID"
+
+       # check that we get the same pathname back
+       local rootpath
+       local found
+       for rootpath in "$submount" "$submount///" "$submount/dir1"; do
+               echo "$rootpath $fid"
+               found=$($LFS fid2path $rootpath "$fid")
+               [ -n "found" ] || error "fid2path should succeed"
+               [ "$found" == "$td" ] || error "fid2path $found != $td"
+       done
+       # check wrong root path format
+       rootpath=$submount"_wrong"
+       found=$($LFS fid2path $rootpath "$fid")
+       [ -z "$found" ] || error "fid2path should fail ($rootpath != $submount)"
+
        cleanup_247 $submount
 }
-run_test 247d "running fid2path inside root"
+run_test 247d "running fid2path inside subdirectory root"
 
 # LU-8037
 test_247e() {
@@ -19611,6 +20139,36 @@ test_270g() {
 }
 run_test 270g "DoM: default DoM stripe size depends on free space"
 
+test_270h() {
+       [[ $MDS1_VERSION -ge $(version_code 2.13.53) ]] ||
+               skip "Need MDS version at least 2.13.53"
+
+       local mdtname=${FSNAME}-MDT0000-mdtlov
+       local dom=$DIR/$tdir/$tfile
+       local save="$TMP/$TESTSUITE-$TESTNAME.parameters"
+
+       save_lustre_params mds1 "lod.*.dom_stripesize" > $save
+       stack_trap "restore_lustre_params < $save; rm -f $save" EXIT
+
+       $LFS mkdir -i 0 -c 1 $DIR/$tdir
+       $LFS setstripe -E 1M -c1  -E -1 -c2 ${dom}_1 ||
+               error "can't create OST file"
+       # mirrored file with DOM entry in the second mirror
+       $LFS mirror extend -N -E 1M -L mdt -E eof -c2 ${dom}_1 ||
+               error "can't create mirror with DoM component"
+
+       do_facet mds1 $LCTL set_param -n lod.$mdtname.dom_stripesize=0
+
+       # DOM component in the middle and has other enries in the same mirror,
+       # should succeed but lost DoM component
+       $LFS setstripe --copy=${dom}_1 $dom ||
+               error "Can't create file from OST|DOM mirror layout"
+       # check new file has no DoM layout after all
+       [[ $($LFS getstripe -L $dom) != "mdt" ]] ||
+               error "File has DoM component while DoM is disabled"
+}
+run_test 270h "DoM: DoM stripe removal when disabled on server"
+
 test_271a() {
        [ $MDS1_VERSION -lt $(version_code 2.10.55) ] &&
                skip "Need MDS version at least 2.10.55"
@@ -21468,11 +22026,37 @@ test_398c() { # LU-4198
                --filename=$DIR/$tfile
        [ $? -eq 0 ] || error "fio mixed read write error"
 
+       echo "AIO with large block size ${size}M"
+       fio --name=rand-rw --rw=randrw --bs=${size}M --direct=1 \
+               --numjobs=1 --fallocate=none --ioengine=libaio \
+               --iodepth=16 --allow_file_create=0 --size=${size}M \
+               --filename=$DIR/$tfile
+       [ $? -eq 0 ] || error "fio large block size failed"
+
        rm -rf $DIR/$tfile
        $LCTL set_param debug="$saved_debug"
 }
 run_test 398c "run fio to test AIO"
 
+test_398d() { #  LU-13846
+       test -f aiocp || skip_env "no aiocp installed"
+       local aio_file=$DIR/aio_file
+
+       $LFS setstripe -c -1 -S 1M $DIR/$tfile $aio_file
+
+       dd if=/dev/urandom of=$DIR/$tfile bs=1M count=64
+       aiocp -a $PAGE_SIZE -b 64M -s 64M -f O_DIRECT $DIR/$tfile $aio_file
+
+       diff $DIR/$tfile $aio_file || "file diff after aiocp"
+
+       # make sure we don't crash and fail properly
+       aiocp -a 512 -b 64M -s 64M -f O_DIRECT $DIR/$tfile $aio_file &&
+               error "aio not aligned with PAGE SIZE should fail"
+
+       rm -rf $DIR/$tfile $aio_file
+}
+run_test 398d "run aiocp to verify block size > stripe size"
+
 test_fake_rw() {
        local read_write=$1
        if [ "$read_write" = "write" ]; then
@@ -21787,6 +22371,7 @@ test_405() {
                        skip "Layout swap lock is not supported"
 
        check_swap_layouts_support
+       check_swap_layout_no_dom $DIR
 
        test_mkdir $DIR/$tdir
        swap_lock_test -d $DIR/$tdir ||
@@ -21937,6 +22522,8 @@ test_410()
 {
        [[ $CLIENT_VERSION -lt $(version_code 2.9.59) ]] &&
                skip "Need client version at least 2.9.59"
+       [ -f $LUSTRE/tests/kernel/kinode.ko ] ||
+               skip "Need MODULES build"
 
        # Create a file, and stat it from the kernel
        local testfile=$DIR/$tfile
@@ -22776,6 +23363,49 @@ test_423() {
 }
 run_test 423 "statfs should return a right data"
 
+test_424() {
+#define OBD_FAIL_PTLRPC_BULK_REPLY_ATTACH      0x522 | OBD_FAIL_ONCE
+       $LCTL set_param fail_loc=0x80000522
+       dd if=/dev/zero of=$DIR/$tfile bs=2M count=1 oflag=sync
+       rm -f $DIR/$tfile
+}
+run_test 424 "simulate ENOMEM in ptl_send_rpc bulk reply ME attach"
+
+test_425() {
+       test_mkdir -c -1 $DIR/$tdir
+       $LFS setstripe -c -1 $DIR/$tdir
+
+       lru_resize_disable "" 100
+       stack_trap "lru_resize_enable" EXIT
+
+       sleep 5
+
+       for i in $(seq $((MDSCOUNT * 125))); do
+               local t=$DIR/$tdir/$tfile_$i
+
+               dd if=/dev/zero of=$t bs=4K count=1 > /dev/null 2>&1 ||
+                       error_noexit "Create file $t"
+       done
+       stack_trap "rm -rf $DIR/$tdir" EXIT
+
+       for oscparam in $($LCTL list_param ldlm.namespaces.*osc-[-0-9a-f]*); do
+               local lru_size=$($LCTL get_param -n $oscparam.lru_size)
+               local lock_count=$($LCTL get_param -n $oscparam.lock_count)
+
+               [ $lock_count -le $lru_size ] ||
+                       error "osc lock count $lock_count > lru size $lru_size"
+       done
+
+       for mdcparam in $($LCTL list_param ldlm.namespaces.*mdc-*); do
+               local lru_size=$($LCTL get_param -n $mdcparam.lru_size)
+               local lock_count=$($LCTL get_param -n $mdcparam.lock_count)
+
+               [ $lock_count -le $lru_size ] ||
+                       error "mdc lock count $lock_count > lru size $lru_size"
+       done
+}
+run_test 425 "lock count should not exceed lru size"
+
 prep_801() {
        [[ $MDS1_VERSION -lt $(version_code 2.9.55) ]] ||
        [[ $OST1_VERSION -lt $(version_code 2.9.55) ]] &&